<?php

	class IDEALCHECKOUT_FOR_JOOMLA_AND_K2STORE_3_5_1
	{
		// Return the software name
		public static function getSoftwareName()
		{
			return 'Joomla & K2Store 3.5.1+';
		}



		// Return the software code
		public static function getSoftwareCode()
		{
			return str_replace('_', '-', substr(basename(__FILE__), 0, -4));
		}



		// Return path to main cinfig file (if any)
		public static function getConfigFile()
		{
			return SOFTWARE_PATH . DS . 'configuration.php';
		}



		// Return path to main cinfig file (if any)
		public static function getConfigData()
		{
			$sConfigFile = self::getConfigFile();

			// Detect DB settings via configuration file
			if(is_file($sConfigFile))
			{
				return file_get_contents($sConfigFile);
			}

			return '';
		}



		// Find default database settings
		public static function getDatabaseSettings($aSettings)
		{
			$aSettings['db_prefix'] = 'jos_';
			$sConfigData = self::getConfigData();

			if(!empty($sConfigData))
			{
				$aSettings['db_host'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/host = \'([^\']+)\';/');
				$aSettings['db_user'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/user = \'([^\']+)\';/');
				$aSettings['db_pass'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/password = \'([^\']+)\';/');
				$aSettings['db_name'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/db = \'([^\']+)\';/');
				$aSettings['db_prefix'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/dbprefix = \'([^\']+)\';/');
				$aSettings['db_type'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/dbtype = \'([^\']+)\';/');
			}

			return $aSettings;
		}



		// See if current software == self::$sSoftwareCode
		public static function isSoftware()
		{
			$aFiles = array();
			$aFiles[] = SOFTWARE_PATH . DS . 'configuration.php';
			$aFiles[] = SOFTWARE_PATH . DS . 'administrator' . DS . 'components' . DS . 'com_k2store';
			$aFiles[] = SOFTWARE_PATH . DS . 'components' . DS . 'com_k2store';
			// $aFiles[] = SOFTWARE_PATH . DS . 'joomla.xml';

			foreach($aFiles as $sFile)
			{
				if(!is_file($sFile) && !is_dir($sFile))
				{
					return false;
				}
			}

			return true;
		}


		// Install plugin, return text
		public static function doInstall($aSettings)
		{
			IDEALCHECKOUT_INSTALL::doInstall($aSettings);

			
			$sql = "SELECT * FROM `" . $aSettings['db_prefix'] . "extensions` WHERE (`element` = 'idealcheckoutideal') LIMIT 1;";
			if(!idealcheckout_database_isRecord($sql))
			{
				

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutauthorizedtransfer', 'plugin', 'payment_idealcheckoutauthorizedtransfer', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutmaestro', 'plugin', 'payment_idealcheckoutmaestro', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
					
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutmanualtransfer', 'plugin', 'payment_idealcheckoutmanualtransfer', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutmastercard', 'plugin', 'payment_idealcheckoutmastercard', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutvisa', 'plugin', 'payment_idealcheckoutvisa', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutvpay', 'plugin', 'payment_idealcheckoutvpay', 'k2store', 0, 1, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutmistercash', 'plugin', 'payment_idealcheckoutmistercash', 'k2store', 0, 0, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutdirectebanking', 'plugin', 'payment_idealcheckoutdirectebanking', 'k2store', 0, 0, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutpaypal', 'plugin', 'payment_idealcheckoutpaypal', 'k2store', 0, 0, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutpaysafecard', 'plugin', 'payment_idealcheckoutpaysafecard', 'k2store', 0, 0, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (NULL, 'plg_k2store_idealcheckoutcreditcard', 'plugin', 'payment_idealcheckoutcreditcard', 'k2store', 0, 0, 1, 0, '', '', '', '', 0,  '0000-00-00 00:00:00', 0, 0);";
				idealcheckout_database_execute($sql);
				
			}

			$sql = "SHOW COLUMNS FROM `" . $aSettings['db_prefix'] . "idealcheckout_settings` LIKE `webshop_package`";
			
			if(!$aColumn = ic_database_getRecord($sql))
			{
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "idealcheckout_settings` SET
`id` = NULL, 
`keyname` = 'webshop_package',
`value` = 'k2store'";
				ic_database_execute($sql);
				
			}
			else
			{
				$sql = "UPDATE `" . $aSettings['db_prefix'] . "idealcheckout_settings` SET
`value` = 'k2store' WHERE (`keyname` = 'webshop_package') LIMIT 1";
				ic_database_execute($sql);
			}
			
			
			return true;
		}



		// Install plugin, return text
		public static function getInstructions($aSettings)
		{
			$sHtml = '';
			$sHtml .= '<ol>';
			$sHtml .= '<li>Log in op de beheeromgeving van uw webshop.</li>';
			$sHtml .= '<li>Ga in het hoofdmenu naar Componenten / k2Store / Betaalsystemen (Payment Methods).</li>';
			$sHtml .= '<li>Klik rechts bovenin op "Nieuw".</li>';
			$sHtml .= '<li>Geef een naam op voor de betaalmethode (Bijv. iDEAL).</li>';
			$sHtml .= '<li>Zet "publiceren" op "Ja"</li>';
			$sHtml .= '<li>Kies als betaalmethode de waarde "iDEAL Checkout - iDEAL".</li>';
			$sHtml .= '<li>Geef de sorteervolgorde aan.</li>';
			$sHtml .= '<li>Sla de instellingen op.</li>';
			$sHtml .= '<li>Herhaal stap 3 t/m 8 voor de overige betaalmethoden die u wilt aanbieden in uw webshop.</li>';
			$sHtml .= '</ol>';

			return $sHtml;
		}
	}

?>